/*
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License along
 with this program; if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef _config_
#define _config_

#include "IO/IOUtils.h"

// values
#define DEFAULT_SONG_LENGTH 12

// -------------------- my assert stuff -----------------
#include <iostream>

#ifdef _CHECK_FOR_LEAKS
#include "LeakCheck.h"
#else
#define DECLARE_LEAK_CHECK()
#define INIT_LEAK_CHECK()
#endif


#ifdef _MORE_DEBUG_CHECKS

#undef assert
#define assert(expr) if(! (expr)){assertFailed( wxString("Assert failed: ") + wxString( #expr ) + wxString("\n@ ") + extract_filename(__FILE__) + wxString(": ") + to_wxString(__LINE__));}
#define assertExpr(v1,sign,v2) if(!(v1 sign v2)){ assertFailed( wxString("Assert failed: ") + wxString( #v1 ) + wxString( #sign ) + wxString( #v2 ) + wxString("\n@ ") + extract_filename(__FILE__) + wxString(": ") + to_wxString(__LINE__) );}

#else

#undef assert
#define assert(expr)
#define assertExpr(v1,sign,v2)

#endif

#endif
